/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of LibIDN.xs. Do not edit this file, edit LibIDN.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LibIDN.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <idna.h>
#include <punycode.h>
#include <stringprep.h>
#include <idn-free.h>

#ifdef HAVE_TLD
#include <tld.h>
#endif

#define MAX_DNSLEN 4096

static char * default_charset= "ISO-8859-1";

char *
idn_prep(char * string, char * charset, char * profile)
{
	char * output = NULL;
	char * res_str = NULL;
	char * utf8 = NULL;
	int res;
	
    utf8 = stringprep_convert(string, "UTF-8", charset);
	if (!utf8)
		return NULL;

	res = stringprep_profile(utf8, &output, profile, 0);
	idn_free(utf8);

	if( (res != STRINGPREP_OK) || !output)
		return NULL;

	res_str = stringprep_convert(output, charset, "UTF-8");
	idn_free(output);

	return res_str;
}

static double
constant(char *name, int len, int arg)
{
	errno = 0;
	if (0 + 5 >= len )
	{
		errno = EINVAL;
		return 0;
	}
	switch (name[0 + 5]) 
	{
		case 'A':
		if (strEQ(name + 0, "IDNA_ALLOW_UNASSIGNED"))
		{
			return IDNA_ALLOW_UNASSIGNED;
		}
    case 'U':
		if (strEQ(name + 0, "IDNA_USE_STD3_ASCII_RULES"))
		{
			return IDNA_USE_STD3_ASCII_RULES;
		}
	}
	errno = EINVAL;
	return 0;
}

#line 78 "LibIDN.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 222 "LibIDN.c"

XS_EUPXS(XS_Net__LibIDN_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
#line 74 "LibIDN.xs"
	STRLEN		len;
#line 233 "LibIDN.c"
	SV *	sv = ST(0)
;
	char *	s = SvPV(sv, len);
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;
#line 80 "LibIDN.xs"
	RETVAL = constant(s,len,arg);
#line 243 "LibIDN.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_to_ascii); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_to_ascii)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "string, charset=default_charset, flags=0");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
	int	flags;
#line 92 "LibIDN.xs"
		char *	utf8_str = NULL;
		char *	tmp_str = NULL;
		int		res;
#line 266 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 96 "LibIDN.xs"
		utf8_str = stringprep_convert(string, "UTF-8", charset);
		if (utf8_str)
		{
			res = idna_to_ascii_8z(utf8_str, &tmp_str, flags);
			idn_free(utf8_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}
		if (res!=IDNA_SUCCESS)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = tmp_str;
#line 299 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 114 "LibIDN.xs"
		if (tmp_str)
			idn_free(tmp_str);
#line 306 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_to_unicode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_to_unicode)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "string, charset=default_charset, flags=0");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
	int	flags;
#line 125 "LibIDN.xs"
		char *	tmp_str = NULL;
		char *	res_str = NULL;
		int		res;
#line 327 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 129 "LibIDN.xs"
		res = idna_to_unicode_8z8z(string, &tmp_str, flags);
		if(res != IDNA_SUCCESS)
		{
			XSRETURN_UNDEF;
		}
		if (tmp_str)
		{
			res_str = stringprep_convert(tmp_str, charset, "UTF-8");
			idn_free(tmp_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 364 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 151 "LibIDN.xs"
		idn_free(res_str);
#line 370 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_punycode_encode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_punycode_encode)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 160 "LibIDN.xs"
		char *		utf8_str = NULL;
		uint32_t *	q = NULL;
		size_t		len,len2;
		char *		tmp_str = NULL;
		char *		res_str = NULL;
		int			res;
#line 393 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 167 "LibIDN.xs"
		utf8_str = stringprep_convert(string, "UTF-8", charset);
		if (utf8_str)
		{
			q = stringprep_utf8_to_ucs4(utf8_str, -1, &len);
			idn_free(utf8_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}

		if (!q)
		{
			XSRETURN_UNDEF;
		}

		tmp_str = malloc(MAX_DNSLEN*sizeof(char));
		len2 = MAX_DNSLEN-1;
		res = punycode_encode(len, q, NULL, &len2, tmp_str);
		idn_free(q);

		if (res != PUNYCODE_SUCCESS)
		{
			XSRETURN_UNDEF;
		}

		tmp_str[len2] = '\0';	

		res_str = stringprep_convert(tmp_str, charset, "UTF-8");
		free(tmp_str);
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 439 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 205 "LibIDN.xs"
		idn_free(res_str);
#line 445 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_punycode_decode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_punycode_decode)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 214 "LibIDN.xs"
		char *		utf8_str = NULL;
		uint32_t *	q = NULL;
		size_t		len;
		char *		res_str = NULL;
		int			res;
#line 467 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 220 "LibIDN.xs"
		len = MAX_DNSLEN-1;
		q = (uint32_t *) malloc(MAX_DNSLEN * sizeof(q[0]));

		if (q)
		{
			res = punycode_decode(strlen(string), string, &len, q, NULL );
		}
		else
		{
			XSRETURN_UNDEF;
		}
		if (res != PUNYCODE_SUCCESS)
		{
			XSRETURN_UNDEF;
		}
		q[len] = '\0';

		utf8_str = stringprep_ucs4_to_utf8(q, -1, NULL, NULL);
		free(q);

		if (utf8_str)
		{
			res_str = stringprep_convert(utf8_str, charset, "UTF-8");
			idn_free(utf8_str);
		}
		else
		{
			XSRETURN_UNDEF;
		}

		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 513 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 258 "LibIDN.xs"
		idn_free(res_str);
#line 519 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_name)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 267 "LibIDN.xs"
		char *	res_str = NULL;
#line 537 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 269 "LibIDN.xs"
		res_str = idn_prep(string, charset, "Nameprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 554 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 278 "LibIDN.xs"
		idn_free(res_str);
#line 560 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_kerberos5); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_kerberos5)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 287 "LibIDN.xs"
		char *	res_str = NULL;
#line 578 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 289 "LibIDN.xs"
		res_str = idn_prep(string, charset, "KRBprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 595 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 298 "LibIDN.xs"
		idn_free(res_str);
#line 601 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_node)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 306 "LibIDN.xs"
		char *	res_str = NULL;
#line 619 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 308 "LibIDN.xs"
		res_str = idn_prep(string, charset, "Nodeprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 636 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 317 "LibIDN.xs"
		idn_free(res_str);
#line 642 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_resource); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_resource)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 326 "LibIDN.xs"
		char *	res_str = NULL;
#line 660 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 328 "LibIDN.xs"
		res_str = idn_prep(string, charset, "Resourceprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 677 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 337 "LibIDN.xs"
		idn_free(res_str);
#line 683 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_plain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_plain)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 346 "LibIDN.xs"
		char *	res_str = NULL;
#line 701 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 348 "LibIDN.xs"
		res_str = idn_prep(string, charset, "plain");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 718 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 357 "LibIDN.xs"
		idn_free(res_str);
#line 724 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_trace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_trace)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 366 "LibIDN.xs"
		char *	res_str = NULL;
#line 742 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 368 "LibIDN.xs"
		res_str = idn_prep(string, charset, "trace");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 759 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 377 "LibIDN.xs"
		idn_free(res_str);
#line 765 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_sasl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_sasl)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 386 "LibIDN.xs"
		char *	res_str = NULL;
#line 783 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 388 "LibIDN.xs"
		res_str = idn_prep(string, charset, "SASLprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 800 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 397 "LibIDN.xs"
		idn_free(res_str);
#line 806 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_idn_prep_iscsi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_idn_prep_iscsi)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, charset=default_charset");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	char *	charset;
#line 406 "LibIDN.xs"
		char *		res_str = NULL;
#line 824 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    charset = default_charset;
	else {
	    charset = (char *)SvPV_nolen(ST(1))
;
	}
#line 408 "LibIDN.xs"
		res_str = idn_prep(string, charset, "ISCSIprep");
		if (!res_str)
		{
			XSRETURN_UNDEF;
		}
		RETVAL = res_str;
#line 841 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 417 "LibIDN.xs"
		idn_free(res_str);
#line 847 "LibIDN.c"
    }
    XSRETURN(1);
}

#ifdef HAVE_TLD
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Net__LibIDN_tld_check); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_tld_check)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "string, errpos, ...");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
	size_t	errpos = (size_t)SvUV(ST(1))
;
#line 428 "LibIDN.xs"
		STRLEN	c_len;
		char * charset = default_charset;
		char * tld = NULL;
		const Tld_table * tld_table = NULL;
		uint32_t *q;
		size_t len;
		char * utf8_str = NULL;
		char * tmp_str = NULL;
		int res;
#line 877 "LibIDN.c"
	int	RETVAL;
	dXSTARG;
#line 438 "LibIDN.xs"
		if (items>2)
		{
			if (ST(2) != &PL_sv_undef)
				charset = (char*)SvPV(ST(2), c_len);
		}
		if (items>3)
		{
			tld =  (char*)SvPV(ST(3), c_len);
			tld_table = tld_default_table(tld, NULL);
		}
		utf8_str = stringprep_convert(string, "UTF-8", charset);
		if (!utf8_str)
		{
			XSRETURN_UNDEF;
		}
		res = stringprep_profile(utf8_str, &tmp_str, "Nameprep", 0);
		idn_free(utf8_str);
		if (res != STRINGPREP_OK)
		{
			XSRETURN_UNDEF;
		}
		if (tld)
		{
			q = stringprep_utf8_to_ucs4(tmp_str, -1, &len);
			idn_free(tmp_str);
			if (!q)
			{
				XSRETURN_UNDEF;
			}
			res = tld_check_4t(q, len, &errpos, tld_table);
			idn_free(q);
		}
		else
		{
			res = tld_check_8z(tmp_str, &errpos, NULL);
			idn_free(tmp_str);
		}
		if (res == TLD_SUCCESS)
		{
			RETVAL = 1;
		}
		else if (res == TLD_INVALID)
		{
			RETVAL = 0;
		}
		else
		{
			XSRETURN_UNDEF;
		}
#line 930 "LibIDN.c"
	sv_setuv(ST(1), (UV)errpos);
	SvSETMAGIC(ST(1));
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_tld_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_tld_get)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "string");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
#line 496 "LibIDN.xs"
		char *res_str = NULL;
		int res;
#line 952 "LibIDN.c"
	char *	RETVAL;
	dXSTARG;
#line 499 "LibIDN.xs"
		res = tld_get_z(string, &res_str);
		if (res == TLD_SUCCESS)
		{
			RETVAL = res_str;
		}
		else
		{
			XSRETURN_UNDEF;
		}
#line 965 "LibIDN.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
#line 511 "LibIDN.xs"
		idn_free(res_str);
#line 971 "LibIDN.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibIDN_tld_get_table); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibIDN_tld_get_table)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tld");
    {
	char *	tld = (char *)SvPV_nolen(ST(0))
;
#line 519 "LibIDN.xs"
		const Tld_table * tld_table = NULL;
		HV * rh, * reh;
		AV * ra;
		const Tld_table_element *e;
		size_t pos;
#line 992 "LibIDN.c"
	SV *	RETVAL;
#line 525 "LibIDN.xs"
		tld_table = tld_default_table(tld, NULL);
		if (tld_table)
		{
			rh = (HV *)sv_2mortal((SV *)newHV());
			hv_store(rh, "name", 4, newSVpv(tld_table->name, 0), 0);
			hv_store(rh, "version", 7, newSVpv(tld_table->version, 0), 0);
			hv_store(rh, "nvalid", 6, newSVuv(tld_table->nvalid), 0);
			ra = (AV *)sv_2mortal((SV *)newAV());
			for (pos=0, e = tld_table->valid; pos<tld_table->nvalid; pos++,e++)
			{
				reh = (HV *)sv_2mortal((SV *)newHV());
				hv_store(reh, "start", 5, newSVuv(e->start), 0);
				hv_store(reh, "end", 3, newSVuv(e->end), 0);
				av_push(ra, newRV((SV *)reh));
			}
			hv_store(rh, "valid", 5, newRV((SV*)ra), 0);
			RETVAL = newRV((SV*)rh);
		}
		else
		{
			XSRETURN_UNDEF;
		}
#line 1017 "LibIDN.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#endif /* #ifdef HAVE_TLD */
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Net__LibIDN); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__LibIDN)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::LibIDN::constant", XS_Net__LibIDN_constant);
        (void)newXSproto_portable("Net::LibIDN::idn_to_ascii", XS_Net__LibIDN_idn_to_ascii, file, "$;$$");
        (void)newXSproto_portable("Net::LibIDN::idn_to_unicode", XS_Net__LibIDN_idn_to_unicode, file, "$;$$");
        (void)newXSproto_portable("Net::LibIDN::idn_punycode_encode", XS_Net__LibIDN_idn_punycode_encode, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_punycode_decode", XS_Net__LibIDN_idn_punycode_decode, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_name", XS_Net__LibIDN_idn_prep_name, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_kerberos5", XS_Net__LibIDN_idn_prep_kerberos5, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_node", XS_Net__LibIDN_idn_prep_node, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_resource", XS_Net__LibIDN_idn_prep_resource, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_plain", XS_Net__LibIDN_idn_prep_plain, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_trace", XS_Net__LibIDN_idn_prep_trace, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_sasl", XS_Net__LibIDN_idn_prep_sasl, file, "$;$");
        (void)newXSproto_portable("Net::LibIDN::idn_prep_iscsi", XS_Net__LibIDN_idn_prep_iscsi, file, "$;$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Net::LibIDN::tld_check", XS_Net__LibIDN_tld_check, file, "$$;$$");
        (void)newXSproto_portable("Net::LibIDN::tld_get", XS_Net__LibIDN_tld_get, file, "$");
        (void)newXSproto_portable("Net::LibIDN::tld_get_table", XS_Net__LibIDN_tld_get_table, file, "$");
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 1076 "LibIDN.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
